#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=AI-AvAntiAd.ico
#AutoIt3Wrapper_Outfile=AI-AvAntiAd.exe
#AutoIt3Wrapper_Outfile_x64=AI-AvAntiAd_x64.exe
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=Blockiert die Werbeprozesse von Avira
#AutoIt3Wrapper_Res_Fileversion=1.2.1.0
#AutoIt3Wrapper_Res_LegalCopyright=2012 by MJ, Mirxo & Ephesus
#AutoIt3Wrapper_Res_Language=1031
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Res_Field=ProductName|AI-AvAntiAd
#AutoIt3Wrapper_Res_Field=ProductVersion|1.2
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <Constants.au3>
#include <Timers.au3>
#include <Date.au3>

; Allow only one instance

CheckForPreviousInstance()

; Declarations

Opt('MustDeclareVars', 1)
Opt('TrayOnEventMode', 1)
Opt('TrayMenuMode', 1 + 2)

Const $MAX_ADFREE_DAYS = 7 		; Maximum number of ad free days available in selection

Const $DEFAULT_ADFREE_DAYS = 7	; Preselected number of ad free days

Const $PROC_COUNT = 2			; The number of processes to watch

Const $procName[$PROC_COUNT]	= 	['avnotify.exe', _
									'ipmgui.exe']		; Name of executables to observe

Const $POLLING_DELAY = 250 		; Polling time in ms

Const $LabelAppname = 'AI-AvAntiAd'
Const $LabelVersion = 'Version 1.2.1'
Const $LabelActive = 'Werbeblocker ist aktiv'
Const $LabelInactive = 'Werbeblocker ist inaktiv'
Const $LabelAutostartActive = 'Automatisch mit Windows starten ist aktiv'
Const $LabelAutostartInactive = 'Automatisch mit Windows starten ist inaktiv'

Const $HKEY_CU_Run = 'HKEY_CURRENT_USER\SOFTWARE\Microsoft\Windows\CurrentVersion\Run'

Const $configFile = $LabelAppname & '.conf'

Const $SectionSettings = 'Settings'
Const $SectionSettingsKeyStartdate = 'Startdate'
Const $SectionSettingsKeyAllowAd = 'AllowAdEveryXDays'
Const $SectionSettingsKeyAllowAdLastShownDate = 'LastAdShownDate'
Const $SectionStatsBlocked = 'Blocked'
Const $SectionStatsAllowed = 'Allowed'

Global $proc_killcount[$PROC_COUNT]		; count kills for each process
Global $proc_allowedcount[$PROC_COUNT]	; count allowed ads for each process
Global $last_proc_index = -1			; Array index of last process detected (for statistic update)

Global $StartDate = ''					; Start date for statistics
Global $allowAdEveryDays = 0			; Current selection for show ad every x days (0 means every ad is blocked)
Global $lastAdShownDate = ''			; The date where the last ad has been shown to the user

Global $isActive = False				; true, if program is watching for ad
Global $isAutostart = False				; true, if program is started with windows
Global $waitForManualAdClosePid = 0		; = PID (> 0), if an Ad window is currently shown (until user has closed it manually)

Global $timerId = -1					; Timer Handle

; Build tray menu

Global $mnuAbout = TrayCreateItem($LabelAppname & ' - ' & $LabelVersion)
TrayItemSetOnEvent(-1, 'showAboutEvent')

TrayCreateItem('');

Global $mnuStats[$PROC_COUNT + 1]
$mnuStats[0] = TrayCreateItem('NA')
TrayItemSetOnEvent(-1, 'resetStatsEvent')
For $i = 1 To $PROC_COUNT
	$mnuStats[$i] = TrayCreateItem('NA')
	TrayItemSetState(-1, $TRAY_DISABLE)
Next

TrayCreateItem('');

Global $mnuStatus = TrayCreateItem('NA')
TrayItemSetState(-1, $TRAY_UNCHECKED)
TrayItemSetOnEvent(-1, 'toggleStatusEvent')

TrayCreateItem('');

Global $mnuAllowAd = TrayCreateMenu('Werbung erlauben')
Global $mnuAllowAdDays[$MAX_ADFREE_DAYS + 1]
$mnuAllowAdDays[0] = TrayCreateItem('nie', $mnuAllowAd, -1, 1)
TrayItemSetOnEvent(-1, 'setAllowAdEvent')
For $i = 1 To $MAX_ADFREE_DAYS
	$mnuAllowAdDays[$i] = TrayCreateItem('einmal alle  ' & $i & '  Tage', $mnuAllowAd, -1, 1);
	TrayItemSetOnEvent(-1, 'setAllowAdEvent')
Next

TrayCreateItem('', $mnuAllowAd);

Global $mnuLastAllowed1 = TrayCreateItem('Letzte erlaubte Werbung:', $mnuAllowAd)
TrayItemSetState(-1, $TRAY_DISABLE)

Global $mnuLastAllowed2 = TrayCreateItem('NA', $mnuAllowAd)
TrayItemSetState(-1, $TRAY_DISABLE)

TrayCreateItem('');

Global $mnuAutostart = TrayCreateItem('NA')
TrayItemSetState(-1, $TRAY_UNCHECKED)
TrayItemSetOnEvent(-1, 'toggleAutostartEvent')

TrayCreateItem('');

TrayCreateItem('Beenden')
TrayItemSetOnEvent(-1, 'doExitEvent')

TraySetState()

; Init autostart setting

$isAutostart = NOT getAutostartStateFromRegistry()
toggleAutostartEvent()

; Read configuration

readConfigFromFile()

; Activate blocker (is always active when the program starts)

toggleStatusEvent()

; Keep Alive Idle loop

While true
	Sleep(60000)
WEnd

; TRAY MENU EVENT HANDLER

Func showAboutEvent()
	MsgBoxLock(64, 'ber ' & $LabelAppname, $LabelAppname & ' - ' & $LabelVersion & @CRLF & _
				'(c) 2012 by MJ, Mirxo & Ephesus' & @CRLF & @CRLF & 'Blockiert die Werbeprozesse von Avira.')
EndFunc

Func resetStatsEvent()
	Local $res = MsgBoxLock(292, $LabelAppname, 'Wollen Sie die Statistik wirklich zurcksetzen?')
	If $res = 6 Then
		resetConfig()
	EndIf
EndFunc

Func toggleStatusEvent()
	$isActive = Not $isActive

	if $isActive Then
		TrayItemSetState($mnuStatus, $TRAY_CHECKED)
		TrayItemSetText($mnuStatus, $LabelActive)
        TraySetToolTip( $LabelAppname & ' - ' & $LabelActive)
		$timerId = _Timer_SetTimer(0, $POLLING_DELAY, '_TimerFunc')
	Else
		TrayItemSetState($mnuStatus, $TRAY_UNCHECKED)
		TrayItemSetText($mnuStatus, $LabelInActive)
        TraySetToolTip( $LabelAppname & ' - ' & $LabelInactive)
		_Timer_KillTimer(0, $timerId)
	EndIf
EndFunc

Func setAllowAdEvent()
	Local $firstMnuItemId = $mnuAllowAdDays[0]
	$allowAdEveryDays = @TRAY_ID - $firstMnuItemId ; = 0..7
	dispatchConfigChange()
EndFunc

Func toggleAutostartEvent()
	$isAutostart = Not $isAutostart

	if $isAutostart Then
		RegWrite($HKEY_CU_Run, $LabelAppname, 'REG_SZ', @ScriptFullPath)
		TrayItemSetState($mnuAutostart, $TRAY_CHECKED)
		TrayItemSetText($mnuAutostart, $LabelAutostartActive)
	Else
		RegDelete($HKEY_CU_Run, $LabelAppname)
		TrayItemSetState($mnuAutostart, $TRAY_UNCHECKED)
		TrayItemSetText($mnuAutostart, $LabelAutostartInactive)
	EndIf
EndFunc

Func doExitEvent()
	If $isActive Then
		toggleStatusEvent()
	EndIf
	Exit 0
EndFunc

; Kill function, called every 250 ms

Func _TimerFunc($hWnd, $Msg, $iIDTimer, $dwTime)

	; Wait for user to manually close the open ad window

	If $waitForManualAdClosePid <> 0 Then
		If (NOT ProcessExists($waitForManualAdClosePid)) Then
			$waitForManualAdClosePid = 0
		EndIf
	Else

		; Kill ad process (or show it, if allowed by policy)

		Local $Pid = tryGetPid()

		If $Pid <> 0 Then
			If ($allowAdEveryDays = 0) OR (_DateDiff( 'D', $lastAdShownDate, _NowCalc()) < $allowAdEveryDays) Then
				ProcessClose($Pid)
				$proc_killcount[$last_proc_index] += 1
			Else
				$waitForManualAdClosePid = $Pid
				$proc_allowedcount[$last_proc_index] += 1
				$lastAdShownDate = _NowCalc()
			EndIf
			dispatchConfigChange()
		EndIf
	EndIf
EndFunc

; Returns Pid of first process from blocklist, 0 otherweise

Func tryGetPid()
	Local $list = ProcessList()

	For $p = 0 To $PROC_COUNT - 1
		For $i = 1 To $list[0][0]
			If StringCompare($procName[$p], $list[$i][0]) = 0 Then
				$last_proc_index = $p
				Return $list[$i][1]
			EndIf
		Next
	Next

	Return 0
EndFunc

Func resetConfig()
	For $p = 0 To $PROC_COUNT - 1
		$proc_killcount[$p] = 0
		$proc_allowedcount[$p] = 0
	Next
	$StartDate = _NowCalc()
	$allowAdEveryDays = 7
	$lastAdShownDate = _NowCalc()
	writeConfigToFile()
	updateTray()
EndFunc

Func updateTray()
	TrayItemSetText($mnuStats[0], 'Beendete Prozesse seit dem ' & _DateTimeFormat($StartDate, 0) & ':');
	For $p = 0 To $PROC_COUNT - 1
		TrayItemSetText($mnuStats[$p + 1], $procName[$p] & ': ' & $proc_killcount[$p] & ' ( ' & $proc_allowedcount[$p] & ' erlaubt )');
	Next
	TrayItemSetState($mnuAllowAdDays[$allowAdEveryDays], $TRAY_CHECKED)
	TrayItemSetText($mnuLastAllowed2, _DateTimeFormat($lastAdShownDate, 0))
EndFunc

Func dispatchConfigChange()
	updateTray()
	writeConfigToFile()
EndFunc

Func readConfigFromFile()
	$StartDate = IniRead ( $configFile, $SectionSettings, $SectionSettingsKeyStartdate, 'NA' )
	If ($StartDate == 'NA') OR (_DateTimeFormat($StartDate, 0) = '') Then
		resetConfig()
	Else
		$allowAdEveryDays = ValidateStrInt( IniRead ( $configFile, $SectionSettings, $SectionSettingsKeyAllowAd, $DEFAULT_ADFREE_DAYS ), _
									0, $MAX_ADFREE_DAYS, $DEFAULT_ADFREE_DAYS)

		Local $defaultDate = _NowCalc()
		$lastAdShownDate = ValidateDate ( IniRead ( $configFile, $SectionSettings, $SectionSettingsKeyAllowAdLastShownDate, $defaultDate), _
									0, 0xffffff, $defaultDate)
		For $p = 0 To $PROC_COUNT - 1
			$proc_killcount[$p] = ValidateStrInt ( IniRead ( $configFile, $SectionStatsBlocked, $procName[$p], 0 ), _
									0, 0xffffff, 0)
			$proc_allowedcount[$p] = ValidateStrInt ( IniRead ( $configFile, $SectionStatsAllowed, $procName[$p], 0 ), _
									0, 0xffffff, 0)
		Next

		writeConfigToFile() ; Validation may have changed something
		updateTray()
	EndIf
EndFunc

Func writeConfigToFile()
	IniWrite ( $configFile, $SectionSettings, $SectionSettingsKeyStartdate, $StartDate )
	IniWrite ( $configFile, $SectionSettings, $SectionSettingsKeyAllowAd, $allowAdEveryDays )
	IniWrite ( $configFile, $SectionSettings, $SectionSettingsKeyAllowAdLastShownDate, $lastAdShownDate )
	For $p = 0 To $PROC_COUNT - 1
		IniWrite ( $configFile, $SectionStatsBlocked, $procName[$p], $proc_killcount[$p] )
		IniWrite ( $configFile, $SectionStatsAllowed, $procName[$p], $proc_allowedcount[$p] )
	Next
EndFunc

Func getAutostartStateFromRegistry()
	Return (RegRead($HKEY_CU_Run, $LabelAppname) = @ScriptFullPath)
EndFunc

Func CheckForPreviousInstance()
	Local $aProcList = ProcessList ( @ScriptName )
	if $aProcList[0][0] > 1 Then
		Exit -1
	EndIf
EndFunc

Func MsgBoxLock ( $flag, $title, $text )
	TraySetClick ( 0 )
	Local $res = MsgBox( $flag, $title, $text)
	TraySetClick ( 9 )
	Return $res
EndFunc

Func ValidateStrInt($strValue, $intMin, $intMax, $intDefault)
	Local $intRes = $intDefault
	If (StringIsInt($strValue)) Then
		$intRes = Int($strValue)
		If ($intRes < $intMin) OR ($intRes > $intMax) Then
			$intRes = $intDefault
		EndIf
	EndIf
	Return $intRes
EndFunc

Func ValidateDate($date, $minDayDiff, $maxDayDiff, $default)
	Local $now = _NowCalc()
	Local $dayDiff = _DateDiff('D', $date, $now);
	If (($dayDiff = 0) AND (@error <> 0)) OR ($dayDiff < $minDayDiff) OR ($dayDiff > $maxDayDiff) Then
		$date = $default
	EndIf
	Return $date
EndFunc